// services/network/public/mojom/oblivious_http_request.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_OBLIVIOUS_HTTP_REQUEST_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_OBLIVIOUS_HTTP_REQUEST_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/oblivious_http_request.mojom-shared.h"
#include "services/network/public/mojom/oblivious_http_request.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "services/network/public/mojom/isolation_info.mojom-forward.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom.h"
#include "services/network/public/mojom/network_param.mojom.h"
#include "services/network/public/mojom/trust_tokens.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace network::mojom {

class ObliviousHttpClientProxy;

template <typename ImplRefTraits>
class ObliviousHttpClientStub;

class ObliviousHttpClientRequestValidator;


class ObliviousHttpClient
    : public ObliviousHttpClientInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ObliviousHttpClientInterfaceBase;
  using Proxy_ = ObliviousHttpClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = ObliviousHttpClientStub<ImplRefTraits>;

  using RequestValidator_ = ObliviousHttpClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnCompletedMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnCompleted_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ObliviousHttpClient() = default;

  
  virtual void OnCompleted(ObliviousHttpCompletionResultPtr response) = 0;
};



class  ObliviousHttpClientProxy
    : public ObliviousHttpClient {
 public:
  using InterfaceType = ObliviousHttpClient;

  explicit ObliviousHttpClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnCompleted(ObliviousHttpCompletionResultPtr response) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ObliviousHttpClientStubDispatch {
 public:
  static bool Accept(ObliviousHttpClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ObliviousHttpClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ObliviousHttpClient>>
class ObliviousHttpClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ObliviousHttpClientStub() = default;
  ~ObliviousHttpClientStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ObliviousHttpClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ObliviousHttpClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ObliviousHttpClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  ObliviousHttpRequestBody {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ObliviousHttpRequestBody, T>::value>;
  using DataView = ObliviousHttpRequestBodyDataView;
  using Data_ = internal::ObliviousHttpRequestBody_Data;

  template <typename... Args>
  static ObliviousHttpRequestBodyPtr New(Args&&... args) {
    return ObliviousHttpRequestBodyPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ObliviousHttpRequestBodyPtr From(const U& u) {
    return mojo::TypeConverter<ObliviousHttpRequestBodyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ObliviousHttpRequestBody>::Convert(*this);
  }


  ObliviousHttpRequestBody();

  ObliviousHttpRequestBody(
      const std::string& content,
      const std::string& content_type);


  ~ObliviousHttpRequestBody();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ObliviousHttpRequestBodyPtr>
  ObliviousHttpRequestBodyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ObliviousHttpRequestBody::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ObliviousHttpRequestBody::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ObliviousHttpRequestBody_UnserializedMessageContext<
            UserType, ObliviousHttpRequestBody::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ObliviousHttpRequestBody::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ObliviousHttpRequestBody::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ObliviousHttpRequestBody_UnserializedMessageContext<
            UserType, ObliviousHttpRequestBody::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ObliviousHttpRequestBody::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string content;
  
  std::string content_type;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  ObliviousHttpPaddingParameters {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ObliviousHttpPaddingParameters, T>::value>;
  using DataView = ObliviousHttpPaddingParametersDataView;
  using Data_ = internal::ObliviousHttpPaddingParameters_Data;

  template <typename... Args>
  static ObliviousHttpPaddingParametersPtr New(Args&&... args) {
    return ObliviousHttpPaddingParametersPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ObliviousHttpPaddingParametersPtr From(const U& u) {
    return mojo::TypeConverter<ObliviousHttpPaddingParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ObliviousHttpPaddingParameters>::Convert(*this);
  }


  ObliviousHttpPaddingParameters();

  ObliviousHttpPaddingParameters(
      bool add_exponential_pad,
      uint16_t exponential_mean,
      bool pad_to_next_power_of_two);


  ~ObliviousHttpPaddingParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ObliviousHttpPaddingParametersPtr>
  ObliviousHttpPaddingParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ObliviousHttpPaddingParameters::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ObliviousHttpPaddingParameters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ObliviousHttpPaddingParameters_UnserializedMessageContext<
            UserType, ObliviousHttpPaddingParameters::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ObliviousHttpPaddingParameters::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ObliviousHttpPaddingParameters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ObliviousHttpPaddingParameters_UnserializedMessageContext<
            UserType, ObliviousHttpPaddingParameters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ObliviousHttpPaddingParameters::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool add_exponential_pad;
  
  uint16_t exponential_mean;
  
  bool pad_to_next_power_of_two;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  ObliviousHttpCompletionResult {
 public:
  using DataView = ObliviousHttpCompletionResultDataView;
  using Data_ = internal::ObliviousHttpCompletionResult_Data;
  using Tag = Data_::ObliviousHttpCompletionResult_Tag;

  template <typename... Args>
  static ObliviousHttpCompletionResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |net_error|.
  static ObliviousHttpCompletionResultPtr
  NewNetError(
      int32_t net_error) {
    auto result = ObliviousHttpCompletionResultPtr(absl::in_place);
    result->set_net_error(std::move(net_error));
    return result;
  }
  // Construct an instance holding |outer_response_error_code|.
  static ObliviousHttpCompletionResultPtr
  NewOuterResponseErrorCode(
      int32_t outer_response_error_code) {
    auto result = ObliviousHttpCompletionResultPtr(absl::in_place);
    result->set_outer_response_error_code(std::move(outer_response_error_code));
    return result;
  }
  // Construct an instance holding |inner_response|.
  static ObliviousHttpCompletionResultPtr
  NewInnerResponse(
      ObliviousHttpResponsePtr inner_response) {
    auto result = ObliviousHttpCompletionResultPtr(absl::in_place);
    result->set_inner_response(std::move(inner_response));
    return result;
  }

  template <typename U>
  static ObliviousHttpCompletionResultPtr From(const U& u) {
    return mojo::TypeConverter<ObliviousHttpCompletionResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ObliviousHttpCompletionResult>::Convert(*this);
  }

  ObliviousHttpCompletionResult();
  ~ObliviousHttpCompletionResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  ObliviousHttpCompletionResult(const ObliviousHttpCompletionResult& other) = delete;
  ObliviousHttpCompletionResult& operator=(const ObliviousHttpCompletionResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = ObliviousHttpCompletionResultPtr>
  ObliviousHttpCompletionResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ObliviousHttpCompletionResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, ObliviousHttpCompletionResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_net_error() const { return tag_ == Tag::kNetError; }

  
  int32_t get_net_error() const {
    CHECK(tag_ == Tag::kNetError);
    return data_.net_error;
  }

  
  void set_net_error(
      int32_t net_error);
  
  bool is_outer_response_error_code() const { return tag_ == Tag::kOuterResponseErrorCode; }

  
  int32_t get_outer_response_error_code() const {
    CHECK(tag_ == Tag::kOuterResponseErrorCode);
    return data_.outer_response_error_code;
  }

  
  void set_outer_response_error_code(
      int32_t outer_response_error_code);
  
  bool is_inner_response() const { return tag_ == Tag::kInnerResponse; }

  
  ObliviousHttpResponsePtr& get_inner_response() const {
    CHECK(tag_ == Tag::kInnerResponse);
    return *(data_.inner_response);
  }

  
  void set_inner_response(
      ObliviousHttpResponsePtr inner_response);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ObliviousHttpCompletionResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<ObliviousHttpCompletionResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    int32_t net_error;
    int32_t outer_response_error_code;
    ObliviousHttpResponsePtr* inner_response;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};






class  ObliviousHttpResponse {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ObliviousHttpResponse, T>::value>;
  using DataView = ObliviousHttpResponseDataView;
  using Data_ = internal::ObliviousHttpResponse_Data;

  template <typename... Args>
  static ObliviousHttpResponsePtr New(Args&&... args) {
    return ObliviousHttpResponsePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ObliviousHttpResponsePtr From(const U& u) {
    return mojo::TypeConverter<ObliviousHttpResponsePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ObliviousHttpResponse>::Convert(*this);
  }


  ObliviousHttpResponse();

  ObliviousHttpResponse(
      int32_t response_code,
      const ::scoped_refptr<::net::HttpResponseHeaders>& headers,
      const std::string& response_body);


  ~ObliviousHttpResponse();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ObliviousHttpResponsePtr>
  ObliviousHttpResponsePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ObliviousHttpResponse::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ObliviousHttpResponse::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ObliviousHttpResponse_UnserializedMessageContext<
            UserType, ObliviousHttpResponse::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ObliviousHttpResponse::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ObliviousHttpResponse::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ObliviousHttpResponse_UnserializedMessageContext<
            UserType, ObliviousHttpResponse::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ObliviousHttpResponse::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t response_code;
  
  ::scoped_refptr<::net::HttpResponseHeaders> headers;
  
  std::string response_body;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ObliviousHttpResponse::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  ObliviousHttpRequest {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ObliviousHttpRequest, T>::value>;
  using DataView = ObliviousHttpRequestDataView;
  using Data_ = internal::ObliviousHttpRequest_Data;

  template <typename... Args>
  static ObliviousHttpRequestPtr New(Args&&... args) {
    return ObliviousHttpRequestPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ObliviousHttpRequestPtr From(const U& u) {
    return mojo::TypeConverter<ObliviousHttpRequestPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ObliviousHttpRequest>::Convert(*this);
  }


  ObliviousHttpRequest();

  ObliviousHttpRequest(
      const ::GURL& relay_url,
      const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation,
      absl::optional<::base::TimeDelta> timeout_duration,
      const std::string& key_config,
      const ::GURL& resource_url,
      const std::string& method,
      ObliviousHttpRequestBodyPtr request_body,
      ::network::mojom::TrustTokenParamsPtr trust_token_params,
      ObliviousHttpPaddingParametersPtr padding_params);

ObliviousHttpRequest(const ObliviousHttpRequest&) = delete;
ObliviousHttpRequest& operator=(const ObliviousHttpRequest&) = delete;

  ~ObliviousHttpRequest();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ObliviousHttpRequestPtr>
  ObliviousHttpRequestPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ObliviousHttpRequest::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ObliviousHttpRequest::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ObliviousHttpRequest_UnserializedMessageContext<
            UserType, ObliviousHttpRequest::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ObliviousHttpRequest::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ObliviousHttpRequest::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ObliviousHttpRequest_UnserializedMessageContext<
            UserType, ObliviousHttpRequest::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ObliviousHttpRequest::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::GURL relay_url;
  
  ::net::MutableNetworkTrafficAnnotationTag traffic_annotation;
  
  absl::optional<::base::TimeDelta> timeout_duration;
  
  std::string key_config;
  
  ::GURL resource_url;
  
  std::string method;
  
  ObliviousHttpRequestBodyPtr request_body;
  
  ::network::mojom::TrustTokenParamsPtr trust_token_params;
  
  ObliviousHttpPaddingParametersPtr padding_params;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ObliviousHttpRequest::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
ObliviousHttpCompletionResultPtr ObliviousHttpCompletionResult::Clone() const {
  switch (tag_) {
    case Tag::kNetError:
      return NewNetError(
          mojo::Clone(data_.net_error));
    case Tag::kOuterResponseErrorCode:
      return NewOuterResponseErrorCode(
          mojo::Clone(data_.outer_response_error_code));
    case Tag::kInnerResponse:
      return NewInnerResponse(
          mojo::Clone(*data_.inner_response));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ObliviousHttpCompletionResult>::value>::type*>
bool ObliviousHttpCompletionResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kNetError:
      return mojo::Equals(data_.net_error, other.data_.net_error);
    case Tag::kOuterResponseErrorCode:
      return mojo::Equals(data_.outer_response_error_code, other.data_.outer_response_error_code);
    case Tag::kInnerResponse:
      return mojo::Equals(*(data_.inner_response), *(other.data_.inner_response));
  }

  return false;
}
template <typename StructPtrType>
ObliviousHttpRequestBodyPtr ObliviousHttpRequestBody::Clone() const {
  return New(
      mojo::Clone(content),
      mojo::Clone(content_type)
  );
}

template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>*>
bool ObliviousHttpRequestBody::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->content, other_struct.content))
    return false;
  if (!mojo::Equals(this->content_type, other_struct.content_type))
    return false;
  return true;
}

template <typename T, ObliviousHttpRequestBody::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.content < rhs.content)
    return true;
  if (rhs.content < lhs.content)
    return false;
  if (lhs.content_type < rhs.content_type)
    return true;
  if (rhs.content_type < lhs.content_type)
    return false;
  return false;
}
template <typename StructPtrType>
ObliviousHttpResponsePtr ObliviousHttpResponse::Clone() const {
  return New(
      mojo::Clone(response_code),
      mojo::Clone(headers),
      mojo::Clone(response_body)
  );
}

template <typename T, ObliviousHttpResponse::EnableIfSame<T>*>
bool ObliviousHttpResponse::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->response_code, other_struct.response_code))
    return false;
  if (!mojo::Equals(this->headers, other_struct.headers))
    return false;
  if (!mojo::Equals(this->response_body, other_struct.response_body))
    return false;
  return true;
}

template <typename T, ObliviousHttpResponse::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.response_code < rhs.response_code)
    return true;
  if (rhs.response_code < lhs.response_code)
    return false;
  if (lhs.headers < rhs.headers)
    return true;
  if (rhs.headers < lhs.headers)
    return false;
  if (lhs.response_body < rhs.response_body)
    return true;
  if (rhs.response_body < lhs.response_body)
    return false;
  return false;
}
template <typename StructPtrType>
ObliviousHttpPaddingParametersPtr ObliviousHttpPaddingParameters::Clone() const {
  return New(
      mojo::Clone(add_exponential_pad),
      mojo::Clone(exponential_mean),
      mojo::Clone(pad_to_next_power_of_two)
  );
}

template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>*>
bool ObliviousHttpPaddingParameters::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->add_exponential_pad, other_struct.add_exponential_pad))
    return false;
  if (!mojo::Equals(this->exponential_mean, other_struct.exponential_mean))
    return false;
  if (!mojo::Equals(this->pad_to_next_power_of_two, other_struct.pad_to_next_power_of_two))
    return false;
  return true;
}

template <typename T, ObliviousHttpPaddingParameters::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.add_exponential_pad < rhs.add_exponential_pad)
    return true;
  if (rhs.add_exponential_pad < lhs.add_exponential_pad)
    return false;
  if (lhs.exponential_mean < rhs.exponential_mean)
    return true;
  if (rhs.exponential_mean < lhs.exponential_mean)
    return false;
  if (lhs.pad_to_next_power_of_two < rhs.pad_to_next_power_of_two)
    return true;
  if (rhs.pad_to_next_power_of_two < lhs.pad_to_next_power_of_two)
    return false;
  return false;
}
template <typename StructPtrType>
ObliviousHttpRequestPtr ObliviousHttpRequest::Clone() const {
  return New(
      mojo::Clone(relay_url),
      mojo::Clone(traffic_annotation),
      mojo::Clone(timeout_duration),
      mojo::Clone(key_config),
      mojo::Clone(resource_url),
      mojo::Clone(method),
      mojo::Clone(request_body),
      mojo::Clone(trust_token_params),
      mojo::Clone(padding_params)
  );
}

template <typename T, ObliviousHttpRequest::EnableIfSame<T>*>
bool ObliviousHttpRequest::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->relay_url, other_struct.relay_url))
    return false;
  if (!mojo::Equals(this->traffic_annotation, other_struct.traffic_annotation))
    return false;
  if (!mojo::Equals(this->timeout_duration, other_struct.timeout_duration))
    return false;
  if (!mojo::Equals(this->key_config, other_struct.key_config))
    return false;
  if (!mojo::Equals(this->resource_url, other_struct.resource_url))
    return false;
  if (!mojo::Equals(this->method, other_struct.method))
    return false;
  if (!mojo::Equals(this->request_body, other_struct.request_body))
    return false;
  if (!mojo::Equals(this->trust_token_params, other_struct.trust_token_params))
    return false;
  if (!mojo::Equals(this->padding_params, other_struct.padding_params))
    return false;
  return true;
}

template <typename T, ObliviousHttpRequest::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.relay_url < rhs.relay_url)
    return true;
  if (rhs.relay_url < lhs.relay_url)
    return false;
  if (lhs.traffic_annotation < rhs.traffic_annotation)
    return true;
  if (rhs.traffic_annotation < lhs.traffic_annotation)
    return false;
  if (lhs.timeout_duration < rhs.timeout_duration)
    return true;
  if (rhs.timeout_duration < lhs.timeout_duration)
    return false;
  if (lhs.key_config < rhs.key_config)
    return true;
  if (rhs.key_config < lhs.key_config)
    return false;
  if (lhs.resource_url < rhs.resource_url)
    return true;
  if (rhs.resource_url < lhs.resource_url)
    return false;
  if (lhs.method < rhs.method)
    return true;
  if (rhs.method < lhs.method)
    return false;
  if (lhs.request_body < rhs.request_body)
    return true;
  if (rhs.request_body < lhs.request_body)
    return false;
  if (lhs.trust_token_params < rhs.trust_token_params)
    return true;
  if (rhs.trust_token_params < lhs.trust_token_params)
    return false;
  if (lhs.padding_params < rhs.padding_params)
    return true;
  if (rhs.padding_params < lhs.padding_params)
    return false;
  return false;
}


}  // network::mojom

namespace mojo {


template <>
struct  StructTraits<::network::mojom::ObliviousHttpRequestBody::DataView,
                                         ::network::mojom::ObliviousHttpRequestBodyPtr> {
  static bool IsNull(const ::network::mojom::ObliviousHttpRequestBodyPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ObliviousHttpRequestBodyPtr* output) { output->reset(); }

  static const decltype(::network::mojom::ObliviousHttpRequestBody::content)& content(
      const ::network::mojom::ObliviousHttpRequestBodyPtr& input) {
    return input->content;
  }

  static const decltype(::network::mojom::ObliviousHttpRequestBody::content_type)& content_type(
      const ::network::mojom::ObliviousHttpRequestBodyPtr& input) {
    return input->content_type;
  }

  static bool Read(::network::mojom::ObliviousHttpRequestBody::DataView input, ::network::mojom::ObliviousHttpRequestBodyPtr* output);
};


template <>
struct  StructTraits<::network::mojom::ObliviousHttpResponse::DataView,
                                         ::network::mojom::ObliviousHttpResponsePtr> {
  static bool IsNull(const ::network::mojom::ObliviousHttpResponsePtr& input) { return !input; }
  static void SetToNull(::network::mojom::ObliviousHttpResponsePtr* output) { output->reset(); }

  static decltype(::network::mojom::ObliviousHttpResponse::response_code) response_code(
      const ::network::mojom::ObliviousHttpResponsePtr& input) {
    return input->response_code;
  }

  static const decltype(::network::mojom::ObliviousHttpResponse::headers)& headers(
      const ::network::mojom::ObliviousHttpResponsePtr& input) {
    return input->headers;
  }

  static const decltype(::network::mojom::ObliviousHttpResponse::response_body)& response_body(
      const ::network::mojom::ObliviousHttpResponsePtr& input) {
    return input->response_body;
  }

  static bool Read(::network::mojom::ObliviousHttpResponse::DataView input, ::network::mojom::ObliviousHttpResponsePtr* output);
};


template <>
struct  StructTraits<::network::mojom::ObliviousHttpPaddingParameters::DataView,
                                         ::network::mojom::ObliviousHttpPaddingParametersPtr> {
  static bool IsNull(const ::network::mojom::ObliviousHttpPaddingParametersPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ObliviousHttpPaddingParametersPtr* output) { output->reset(); }

  static decltype(::network::mojom::ObliviousHttpPaddingParameters::add_exponential_pad) add_exponential_pad(
      const ::network::mojom::ObliviousHttpPaddingParametersPtr& input) {
    return input->add_exponential_pad;
  }

  static decltype(::network::mojom::ObliviousHttpPaddingParameters::exponential_mean) exponential_mean(
      const ::network::mojom::ObliviousHttpPaddingParametersPtr& input) {
    return input->exponential_mean;
  }

  static decltype(::network::mojom::ObliviousHttpPaddingParameters::pad_to_next_power_of_two) pad_to_next_power_of_two(
      const ::network::mojom::ObliviousHttpPaddingParametersPtr& input) {
    return input->pad_to_next_power_of_two;
  }

  static bool Read(::network::mojom::ObliviousHttpPaddingParameters::DataView input, ::network::mojom::ObliviousHttpPaddingParametersPtr* output);
};


template <>
struct  StructTraits<::network::mojom::ObliviousHttpRequest::DataView,
                                         ::network::mojom::ObliviousHttpRequestPtr> {
  static bool IsNull(const ::network::mojom::ObliviousHttpRequestPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ObliviousHttpRequestPtr* output) { output->reset(); }

  static const decltype(::network::mojom::ObliviousHttpRequest::relay_url)& relay_url(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->relay_url;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::traffic_annotation)& traffic_annotation(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->traffic_annotation;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::timeout_duration)& timeout_duration(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->timeout_duration;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::key_config)& key_config(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->key_config;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::resource_url)& resource_url(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->resource_url;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::method)& method(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->method;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::request_body)& request_body(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->request_body;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::trust_token_params)& trust_token_params(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->trust_token_params;
  }

  static const decltype(::network::mojom::ObliviousHttpRequest::padding_params)& padding_params(
      const ::network::mojom::ObliviousHttpRequestPtr& input) {
    return input->padding_params;
  }

  static bool Read(::network::mojom::ObliviousHttpRequest::DataView input, ::network::mojom::ObliviousHttpRequestPtr* output);
};


template <>
struct  UnionTraits<::network::mojom::ObliviousHttpCompletionResult::DataView,
                                        ::network::mojom::ObliviousHttpCompletionResultPtr> {
  static bool IsNull(const ::network::mojom::ObliviousHttpCompletionResultPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ObliviousHttpCompletionResultPtr* output) { output->reset(); }

  static ::network::mojom::ObliviousHttpCompletionResult::Tag GetTag(const ::network::mojom::ObliviousHttpCompletionResultPtr& input) {
    return input->which();
  }

  static  int32_t net_error(const ::network::mojom::ObliviousHttpCompletionResultPtr& input) {
    return input->get_net_error();
  }

  static  int32_t outer_response_error_code(const ::network::mojom::ObliviousHttpCompletionResultPtr& input) {
    return input->get_outer_response_error_code();
  }

  static const ::network::mojom::ObliviousHttpResponsePtr& inner_response(const ::network::mojom::ObliviousHttpCompletionResultPtr& input) {
    return input->get_inner_response();
  }

  static bool Read(::network::mojom::ObliviousHttpCompletionResult::DataView input, ::network::mojom::ObliviousHttpCompletionResultPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_OBLIVIOUS_HTTP_REQUEST_MOJOM_H_