// services/network/public/mojom/site_for_cookies.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_SITE_FOR_COOKIES_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_SITE_FOR_COOKIES_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/site_for_cookies.mojom-shared.h"
#include "services/network/public/mojom/site_for_cookies.mojom-forward.h"
#include "services/network/public/mojom/schemeful_site.mojom.h"
#include <string>
#include <vector>




#include "services/network/public/cpp/cookie_manager_shared_mojom_traits.h"




namespace network::mojom {








class  SiteForCookies {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SiteForCookies, T>::value>;
  using DataView = SiteForCookiesDataView;
  using Data_ = internal::SiteForCookies_Data;

  template <typename... Args>
  static SiteForCookiesPtr New(Args&&... args) {
    return SiteForCookiesPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SiteForCookiesPtr From(const U& u) {
    return mojo::TypeConverter<SiteForCookiesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SiteForCookies>::Convert(*this);
  }


  SiteForCookies();

  SiteForCookies(
      const ::net::SchemefulSite& site,
      bool schemefully_same,
      const std::string& first_party_url);


  ~SiteForCookies();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SiteForCookiesPtr>
  SiteForCookiesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SiteForCookies::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SiteForCookies::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SiteForCookies_UnserializedMessageContext<
            UserType, SiteForCookies::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SiteForCookies::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SiteForCookies::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SiteForCookies_UnserializedMessageContext<
            UserType, SiteForCookies::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SiteForCookies::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::SchemefulSite site;
  
  bool schemefully_same;
  
  std::string first_party_url;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SiteForCookies::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SiteForCookiesPtr SiteForCookies::Clone() const {
  return New(
      mojo::Clone(site),
      mojo::Clone(schemefully_same),
      mojo::Clone(first_party_url)
  );
}

template <typename T, SiteForCookies::EnableIfSame<T>*>
bool SiteForCookies::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->site, other_struct.site))
    return false;
  if (!mojo::Equals(this->schemefully_same, other_struct.schemefully_same))
    return false;
  if (!mojo::Equals(this->first_party_url, other_struct.first_party_url))
    return false;
  return true;
}

template <typename T, SiteForCookies::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.site < rhs.site)
    return true;
  if (rhs.site < lhs.site)
    return false;
  if (lhs.schemefully_same < rhs.schemefully_same)
    return true;
  if (rhs.schemefully_same < lhs.schemefully_same)
    return false;
  if (lhs.first_party_url < rhs.first_party_url)
    return true;
  if (rhs.first_party_url < lhs.first_party_url)
    return false;
  return false;
}


}  // network::mojom

namespace mojo {


template <>
struct  StructTraits<::network::mojom::SiteForCookies::DataView,
                                         ::network::mojom::SiteForCookiesPtr> {
  static bool IsNull(const ::network::mojom::SiteForCookiesPtr& input) { return !input; }
  static void SetToNull(::network::mojom::SiteForCookiesPtr* output) { output->reset(); }

  static const decltype(::network::mojom::SiteForCookies::site)& site(
      const ::network::mojom::SiteForCookiesPtr& input) {
    return input->site;
  }

  static decltype(::network::mojom::SiteForCookies::schemefully_same) schemefully_same(
      const ::network::mojom::SiteForCookiesPtr& input) {
    return input->schemefully_same;
  }

  static const decltype(::network::mojom::SiteForCookies::first_party_url)& first_party_url(
      const ::network::mojom::SiteForCookiesPtr& input) {
    return input->first_party_url;
  }

  static bool Read(::network::mojom::SiteForCookies::DataView input, ::network::mojom::SiteForCookiesPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_SITE_FOR_COOKIES_MOJOM_H_