// services/webnn/public/mojom/webnn_graph.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/webnn/public/mojom/webnn_graph.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/webnn/public/mojom/webnn_graph.mojom-params-data.h"
namespace webnn {
namespace mojom {

NOINLINE static const char* InputOperandLayoutToStringHelper(InputOperandLayout value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case InputOperandLayout::kChannelsFirst:
      return "kChannelsFirst";
    case InputOperandLayout::kChannelsLast:
      return "kChannelsLast";
    default:
      return nullptr;
  }
}

std::string InputOperandLayoutToString(InputOperandLayout value) {
  const char *str = InputOperandLayoutToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown InputOperandLayout value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, InputOperandLayout value) {
  return os << InputOperandLayoutToString(value);
}

NOINLINE static const char* ComputeResultToStringHelper(ComputeResult value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ComputeResult::kOk:
      return "kOk";
    case ComputeResult::kInvalidInputs:
      return "kInvalidInputs";
    case ComputeResult::kUnknownError:
      return "kUnknownError";
    default:
      return nullptr;
  }
}

std::string ComputeResultToString(ComputeResult value) {
  const char *str = ComputeResultToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ComputeResult value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ComputeResult value) {
  return os << ComputeResultToString(value);
}

NOINLINE static const char* Operand_DataTypeToStringHelper(Operand_DataType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case Operand_DataType::kFloat32:
      return "kFloat32";
    case Operand_DataType::kFloat16:
      return "kFloat16";
    case Operand_DataType::kInt32:
      return "kInt32";
    case Operand_DataType::kUint32:
      return "kUint32";
    case Operand_DataType::kInt8:
      return "kInt8";
    case Operand_DataType::kUint8:
      return "kUint8";
    default:
      return nullptr;
  }
}

std::string Operand_DataTypeToString(Operand_DataType value) {
  const char *str = Operand_DataTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown Operand_DataType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, Operand_DataType value) {
  return os << Operand_DataTypeToString(value);
}

NOINLINE static const char* Operand_KindToStringHelper(Operand_Kind value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case Operand_Kind::kInput:
      return "kInput";
    case Operand_Kind::kConstant:
      return "kConstant";
    case Operand_Kind::kOutput:
      return "kOutput";
    default:
      return nullptr;
  }
}

std::string Operand_KindToString(Operand_Kind value) {
  const char *str = Operand_KindToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown Operand_Kind value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, Operand_Kind value) {
  return os << Operand_KindToString(value);
}

NOINLINE static const char* Operator_KindToStringHelper(Operator_Kind value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case Operator_Kind::kClamp:
      return "kClamp";
    case Operator_Kind::kConv2d:
      return "kConv2d";
    case Operator_Kind::kAdd:
      return "kAdd";
    case Operator_Kind::kSub:
      return "kSub";
    case Operator_Kind::kMul:
      return "kMul";
    case Operator_Kind::kDiv:
      return "kDiv";
    case Operator_Kind::kMax:
      return "kMax";
    case Operator_Kind::kMin:
      return "kMin";
    case Operator_Kind::kGemm:
      return "kGemm";
    case Operator_Kind::kAveragePool2d:
      return "kAveragePool2d";
    case Operator_Kind::kMaxPool2d:
      return "kMaxPool2d";
    case Operator_Kind::kRelu:
      return "kRelu";
    case Operator_Kind::kReshape:
      return "kReshape";
    case Operator_Kind::kSoftmax:
      return "kSoftmax";
    default:
      return nullptr;
  }
}

std::string Operator_KindToString(Operator_Kind value) {
  const char *str = Operator_KindToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown Operator_Kind value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, Operator_Kind value) {
  return os << Operator_KindToString(value);
}

namespace internal {
// static
bool OperatorAttributes_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const OperatorAttributes_Data* object = static_cast<const OperatorAttributes_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case OperatorAttributes_Tag::kClamp: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_clamp, 1, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_clamp, validation_context))
        return false;
      return true;
    }
    case OperatorAttributes_Tag::kConv2d: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_conv2d, 2, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_conv2d, validation_context))
        return false;
      return true;
    }
    case OperatorAttributes_Tag::kGemm: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_gemm, 3, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_gemm, validation_context))
        return false;
      return true;
    }
    case OperatorAttributes_Tag::kPool2d: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_pool2d, 4, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_pool2d, validation_context))
        return false;
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in OperatorAttributes");
      return false;
    }
  }
}


// static
bool Operand_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Operand_Data* object =
      static_cast<const Operand_Data*>(data);


  if (!::webnn::mojom::internal::Operand_Kind_Data
        ::Validate(object->kind, validation_context))
    return false;


  if (!::webnn::mojom::internal::Operand_DataType_Data
        ::Validate(object->data_type, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->dimensions, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& dimensions_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->dimensions, validation_context,
                                         &dimensions_validate_params)) {
    return false;
  }

  constexpr const mojo::internal::ContainerValidateParams& name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }

  return true;
}

Operand_Data::Operand_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ClampAttributes_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ClampAttributes_Data* object =
      static_cast<const ClampAttributes_Data*>(data);

  return true;
}

ClampAttributes_Data::ClampAttributes_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Size2d_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Size2d_Data* object =
      static_cast<const Size2d_Data*>(data);

  return true;
}

Size2d_Data::Size2d_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Padding2d_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Padding2d_Data* object =
      static_cast<const Padding2d_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->beginning, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->beginning, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->ending, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->ending, validation_context))
    return false;

  return true;
}

Padding2d_Data::Padding2d_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Conv2dAttributes_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 64, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Conv2dAttributes_Data* object =
      static_cast<const Conv2dAttributes_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->padding, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->padding, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->strides, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->strides, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->dilations, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->dilations, validation_context))
    return false;


  if (!::webnn::mojom::internal::InputOperandLayout_Data
        ::Validate(object->input_layout, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->activation, validation_context))
    return false;

  return true;
}

Conv2dAttributes_Data::Conv2dAttributes_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Pool2dAttributes_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Pool2dAttributes_Data* object =
      static_cast<const Pool2dAttributes_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->window_dimensions, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->window_dimensions, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->padding, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->padding, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->strides, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->strides, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->dilations, 4, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->dilations, validation_context))
    return false;


  if (!::webnn::mojom::internal::InputOperandLayout_Data
        ::Validate(object->layout, validation_context))
    return false;

  return true;
}

Pool2dAttributes_Data::Pool2dAttributes_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool GemmAttributes_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const GemmAttributes_Data* object =
      static_cast<const GemmAttributes_Data*>(data);

  return true;
}

GemmAttributes_Data::GemmAttributes_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Operator_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Operator_Data* object =
      static_cast<const Operator_Data*>(data);


  if (!::webnn::mojom::internal::Operator_Kind_Data
        ::Validate(object->kind, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->input_operands, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& input_operands_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->input_operands, validation_context,
                                         &input_operands_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->output_operands, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& output_operands_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->output_operands, validation_context,
                                         &output_operands_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateInlinedUnion(object->attributes, validation_context))
    return false;

  return true;
}

Operator_Data::Operator_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool GraphInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const GraphInfo_Data* object =
      static_cast<const GraphInfo_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->id_to_operand_map, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& id_to_operand_map_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->id_to_operand_map, validation_context,
                                         &id_to_operand_map_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->input_operands, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& input_operands_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->input_operands, validation_context,
                                         &input_operands_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->output_operands, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& output_operands_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->output_operands, validation_context,
                                         &output_operands_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->operators, 4, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& operators_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->operators, validation_context,
                                         &operators_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->constant_id_to_buffer_map, 5, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& constant_id_to_buffer_map_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->constant_id_to_buffer_map, validation_context,
                                         &constant_id_to_buffer_map_validate_params)) {
    return false;
  }

  return true;
}

GraphInfo_Data::GraphInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNGraph_Compute_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNGraph_Compute_Params_Data* object =
      static_cast<const WebNNGraph_Compute_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->named_inputs, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& named_inputs_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->named_inputs, validation_context,
                                         &named_inputs_validate_params)) {
    return false;
  }

  return true;
}

WebNNGraph_Compute_Params_Data::WebNNGraph_Compute_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool WebNNGraph_Compute_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const WebNNGraph_Compute_ResponseParams_Data* object =
      static_cast<const WebNNGraph_Compute_ResponseParams_Data*>(data);


  if (!::webnn::mojom::internal::ComputeResult_Data
        ::Validate(object->result, validation_context))
    return false;

  constexpr const mojo::internal::ContainerValidateParams& named_outputs_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  if (!mojo::internal::ValidateContainer(object->named_outputs, validation_context,
                                         &named_outputs_validate_params)) {
    return false;
  }

  return true;
}

WebNNGraph_Compute_ResponseParams_Data::WebNNGraph_Compute_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace webnn

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::InputOperandLayout>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::InputOperandLayout value) {
  return std::move(context).WriteString(::webnn::mojom::InputOperandLayoutToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::ComputeResult>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::ComputeResult value) {
  return std::move(context).WriteString(::webnn::mojom::ComputeResultToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::Operand_DataType>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::Operand_DataType value) {
  return std::move(context).WriteString(::webnn::mojom::Operand_DataTypeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::Operand_Kind>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::Operand_Kind value) {
  return std::move(context).WriteString(::webnn::mojom::Operand_KindToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::webnn::mojom::Operator_Kind>::WriteIntoTrace(
   perfetto::TracedValue context, ::webnn::mojom::Operator_Kind value) {
  return std::move(context).WriteString(::webnn::mojom::Operator_KindToString(value));
}

} // namespace perfetto