// services/webnn/public/mojom/webnn_service.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/webnn/public/mojom/webnn_service.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/webnn/public/mojom/webnn_service.mojom-params-data.h"
#include "services/webnn/public/mojom/webnn_service.mojom-shared-message-ids.h"

#include "services/webnn/public/mojom/webnn_service.mojom-import-headers.h"
#include "services/webnn/public/mojom/webnn_service.mojom-test-utils.h"


namespace webnn::mojom {
CreateContextOptions::CreateContextOptions()
    : power_preference() {}

CreateContextOptions::CreateContextOptions(
    PowerPreference power_preference_in)
    : power_preference(std::move(power_preference_in)) {}

CreateContextOptions::~CreateContextOptions() = default;
size_t CreateContextOptions::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->power_preference);
  return seed;
}

void CreateContextOptions::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "power_preference"), this->power_preference,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type PowerPreference>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool CreateContextOptions::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char WebNNContext::Name_[] = "webnn.mojom.WebNNContext";

WebNNContext::IPCStableHashFunction WebNNContext::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kWebNNContext_CreateGraph_Name: {
      return &WebNNContext::CreateGraph_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* WebNNContext::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kWebNNContext_CreateGraph_Name:
            return "Receive webnn::mojom::WebNNContext::CreateGraph";
    }
  } else {
    switch (message.name()) {
      case internal::kWebNNContext_CreateGraph_Name:
            return "Receive reply webnn::mojom::WebNNContext::CreateGraph";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t WebNNContext::CreateGraph_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNContext::CreateGraph");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class WebNNContext_CreateGraph_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  WebNNContext_CreateGraph_ForwardToCallback(
      WebNNContext::CreateGraphCallback callback
      ) : callback_(std::move(callback)) {
  }

  WebNNContext_CreateGraph_ForwardToCallback(const WebNNContext_CreateGraph_ForwardToCallback&) = delete;
  WebNNContext_CreateGraph_ForwardToCallback& operator=(const WebNNContext_CreateGraph_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  WebNNContext::CreateGraphCallback callback_;
};

WebNNContextProxy::WebNNContextProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WebNNContextProxy::CreateGraph(
    ::webnn::mojom::GraphInfoPtr in_graph_info, CreateGraphCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNContext::CreateGraph", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("graph_info"), in_graph_info,
                        "<value of type ::webnn::mojom::GraphInfoPtr>");
   });
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kWebNNContext_CreateGraph_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContext_CreateGraph_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->graph_info)::BaseType> graph_info_fragment(
          params.message());
  mojo::internal::Serialize<::webnn::mojom::GraphInfoDataView>(
      in_graph_info, graph_info_fragment);
  params->graph_info.Set(
      graph_info_fragment.is_null() ? nullptr : graph_info_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->graph_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null graph_info in WebNNContext.CreateGraph request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContext::Name_);
  message.set_method_name("CreateGraph");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new WebNNContext_CreateGraph_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class WebNNContext_CreateGraph_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static WebNNContext::CreateGraphCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<WebNNContext_CreateGraph_ProxyToResponder> proxy(
        new WebNNContext_CreateGraph_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&WebNNContext_CreateGraph_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~WebNNContext_CreateGraph_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  WebNNContext_CreateGraph_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
//    DCHECK(!connected)
//        << "WebNNContext::CreateGraphCallback was destroyed without "
//        << "first either being run or its corresponding binding being closed. "
//        << "It is an error to drop response callbacks which still correspond "
//        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::mojo::PendingRemote<::webnn::mojom::WebNNGraph> in_remote);
};

bool WebNNContext_CreateGraph_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::WebNNContext_CreateGraph_ResponseParams_Data* params =
      reinterpret_cast<
          internal::WebNNContext_CreateGraph_ResponseParams_Data*>(
              message->mutable_payload());
  
  bool success = true;
  ::mojo::PendingRemote<::webnn::mojom::WebNNGraph> p_remote{};
  WebNNContext_CreateGraph_ResponseParamsDataView input_data_view(params, message);
  
  if (success) {
    p_remote =
        input_data_view.TakeRemote<decltype(p_remote)>();
  }
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        WebNNContext::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_remote));
  return true;
}

void WebNNContext_CreateGraph_ProxyToResponder::Run(
    ::mojo::PendingRemote<::webnn::mojom::WebNNGraph> in_remote) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply webnn::mojom::WebNNContext::CreateGraph", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("remote"), in_remote,
                        "<value of type ::mojo::PendingRemote<::webnn::mojom::WebNNGraph>>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kWebNNContext_CreateGraph_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContext_CreateGraph_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::webnn::mojom::WebNNGraphInterfaceBase>>(
      in_remote, &params->remote, &params.message());

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContext::Name_);
  message.set_method_name("CreateGraph");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool WebNNContextStubDispatch::Accept(
    WebNNContext* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kWebNNContext_CreateGraph_Name: {
      break;
    }
  }
  return false;
}

// static
bool WebNNContextStubDispatch::AcceptWithResponder(
    WebNNContext* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kWebNNContext_CreateGraph_Name: {

      internal::WebNNContext_CreateGraph_Params_Data* params =
          reinterpret_cast<
              internal::WebNNContext_CreateGraph_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      ::webnn::mojom::GraphInfoPtr p_graph_info{};
      WebNNContext_CreateGraph_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadGraphInfo(&p_graph_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNContext::Name_, 0, false);
        return false;
      }
      WebNNContext::CreateGraphCallback callback =
          WebNNContext_CreateGraph_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateGraph(
std::move(p_graph_info), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWebNNContextValidationInfo[] = {
    {internal::kWebNNContext_CreateGraph_Name,
     {&internal::WebNNContext_CreateGraph_Params_Data::Validate,
      &internal::WebNNContext_CreateGraph_ResponseParams_Data::Validate}},
};

bool WebNNContextRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNContext::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWebNNContextValidationInfo);
}

bool WebNNContextResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNContext::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kWebNNContextValidationInfo);

}
const char WebNNContextProvider::Name_[] = "webnn.mojom.WebNNContextProvider";

WebNNContextProvider::IPCStableHashFunction WebNNContextProvider::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kWebNNContextProvider_CreateWebNNContext_Name: {
      return &WebNNContextProvider::CreateWebNNContext_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* WebNNContextProvider::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kWebNNContextProvider_CreateWebNNContext_Name:
            return "Receive webnn::mojom::WebNNContextProvider::CreateWebNNContext";
    }
  } else {
    switch (message.name()) {
      case internal::kWebNNContextProvider_CreateWebNNContext_Name:
            return "Receive reply webnn::mojom::WebNNContextProvider::CreateWebNNContext";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t WebNNContextProvider::CreateWebNNContext_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNContextProvider::CreateWebNNContext");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class WebNNContextProvider_CreateWebNNContext_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  WebNNContextProvider_CreateWebNNContext_ForwardToCallback(
      WebNNContextProvider::CreateWebNNContextCallback callback
      ) : callback_(std::move(callback)) {
  }

  WebNNContextProvider_CreateWebNNContext_ForwardToCallback(const WebNNContextProvider_CreateWebNNContext_ForwardToCallback&) = delete;
  WebNNContextProvider_CreateWebNNContext_ForwardToCallback& operator=(const WebNNContextProvider_CreateWebNNContext_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  WebNNContextProvider::CreateWebNNContextCallback callback_;
};

WebNNContextProviderProxy::WebNNContextProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WebNNContextProviderProxy::CreateWebNNContext(
    CreateContextOptionsPtr in_options, CreateWebNNContextCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNContextProvider::CreateWebNNContext", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("options"), in_options,
                        "<value of type CreateContextOptionsPtr>");
   });
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kWebNNContextProvider_CreateWebNNContext_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContextProvider_CreateWebNNContext_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->options)::BaseType> options_fragment(
          params.message());
  mojo::internal::Serialize<::webnn::mojom::CreateContextOptionsDataView>(
      in_options, options_fragment);
  params->options.Set(
      options_fragment.is_null() ? nullptr : options_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->options.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null options in WebNNContextProvider.CreateWebNNContext request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContextProvider::Name_);
  message.set_method_name("CreateWebNNContext");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new WebNNContextProvider_CreateWebNNContext_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class WebNNContextProvider_CreateWebNNContext_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static WebNNContextProvider::CreateWebNNContextCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<WebNNContextProvider_CreateWebNNContext_ProxyToResponder> proxy(
        new WebNNContextProvider_CreateWebNNContext_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&WebNNContextProvider_CreateWebNNContext_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~WebNNContextProvider_CreateWebNNContext_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  WebNNContextProvider_CreateWebNNContext_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
//    DCHECK(!connected)
//        << "WebNNContextProvider::CreateWebNNContextCallback was destroyed without "
//        << "first either being run or its corresponding binding being closed. "
//        << "It is an error to drop response callbacks which still correspond "
//        << "to an open interface pipe.";
  }
#endif

  void Run(
      CreateContextResult in_result, ::mojo::PendingRemote<WebNNContext> in_remote);
};

bool WebNNContextProvider_CreateWebNNContext_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::WebNNContextProvider_CreateWebNNContext_ResponseParams_Data* params =
      reinterpret_cast<
          internal::WebNNContextProvider_CreateWebNNContext_ResponseParams_Data*>(
              message->mutable_payload());
  
  bool success = true;
  CreateContextResult p_result{};
  ::mojo::PendingRemote<WebNNContext> p_remote{};
  WebNNContextProvider_CreateWebNNContext_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (success) {
    p_remote =
        input_data_view.TakeRemote<decltype(p_remote)>();
  }
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        WebNNContextProvider::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result), 
std::move(p_remote));
  return true;
}

void WebNNContextProvider_CreateWebNNContext_ProxyToResponder::Run(
    CreateContextResult in_result, ::mojo::PendingRemote<WebNNContext> in_remote) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply webnn::mojom::WebNNContextProvider::CreateWebNNContext", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type CreateContextResult>");
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("remote"), in_remote,
                        "<value of type ::mojo::PendingRemote<WebNNContext>>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kWebNNContextProvider_CreateWebNNContext_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNContextProvider_CreateWebNNContext_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<::webnn::mojom::CreateContextResult>(
      in_result, &params->result);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::webnn::mojom::WebNNContextInterfaceBase>>(
      in_remote, &params->remote, &params.message());

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNContextProvider::Name_);
  message.set_method_name("CreateWebNNContext");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool WebNNContextProviderStubDispatch::Accept(
    WebNNContextProvider* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kWebNNContextProvider_CreateWebNNContext_Name: {
      break;
    }
  }
  return false;
}

// static
bool WebNNContextProviderStubDispatch::AcceptWithResponder(
    WebNNContextProvider* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kWebNNContextProvider_CreateWebNNContext_Name: {

      internal::WebNNContextProvider_CreateWebNNContext_Params_Data* params =
          reinterpret_cast<
              internal::WebNNContextProvider_CreateWebNNContext_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      CreateContextOptionsPtr p_options{};
      WebNNContextProvider_CreateWebNNContext_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadOptions(&p_options))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNContextProvider::Name_, 0, false);
        return false;
      }
      WebNNContextProvider::CreateWebNNContextCallback callback =
          WebNNContextProvider_CreateWebNNContext_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateWebNNContext(
std::move(p_options), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWebNNContextProviderValidationInfo[] = {
    {internal::kWebNNContextProvider_CreateWebNNContext_Name,
     {&internal::WebNNContextProvider_CreateWebNNContext_Params_Data::Validate,
      &internal::WebNNContextProvider_CreateWebNNContext_ResponseParams_Data::Validate}},
};

bool WebNNContextProviderRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNContextProvider::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWebNNContextProviderValidationInfo);
}

bool WebNNContextProviderResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNContextProvider::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kWebNNContextProviderValidationInfo);

}
const char WebNNService::Name_[] = "webnn.mojom.WebNNService";

WebNNService::IPCStableHashFunction WebNNService::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kWebNNService_BindWebNNContextProvider_Name: {
      return &WebNNService::BindWebNNContextProvider_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* WebNNService::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kWebNNService_BindWebNNContextProvider_Name:
            return "Receive webnn::mojom::WebNNService::BindWebNNContextProvider";
    }
  } else {
    switch (message.name()) {
      case internal::kWebNNService_BindWebNNContextProvider_Name:
            return "Receive reply webnn::mojom::WebNNService::BindWebNNContextProvider";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t WebNNService::BindWebNNContextProvider_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNService::BindWebNNContextProvider");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

WebNNServiceProxy::WebNNServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WebNNServiceProxy::BindWebNNContextProvider(
    ::mojo::PendingReceiver<WebNNContextProvider> in_receiver) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNService::BindWebNNContextProvider", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("receiver"), in_receiver,
                        "<value of type ::mojo::PendingReceiver<WebNNContextProvider>>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kWebNNService_BindWebNNContextProvider_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNService_BindWebNNContextProvider_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::webnn::mojom::WebNNContextProviderInterfaceBase>>(
      in_receiver, &params->receiver, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->receiver),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid receiver in WebNNService.BindWebNNContextProvider request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNService::Name_);
  message.set_method_name("BindWebNNContextProvider");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

// static
bool WebNNServiceStubDispatch::Accept(
    WebNNService* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kWebNNService_BindWebNNContextProvider_Name: {

      DCHECK(message->is_serialized());
      internal::WebNNService_BindWebNNContextProvider_Params_Data* params =
          reinterpret_cast<internal::WebNNService_BindWebNNContextProvider_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::mojo::PendingReceiver<WebNNContextProvider> p_receiver{};
      WebNNService_BindWebNNContextProvider_ParamsDataView input_data_view(params, message);
      
      if (success) {
        p_receiver =
            input_data_view.TakeReceiver<decltype(p_receiver)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNService::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->BindWebNNContextProvider(
std::move(p_receiver));
      return true;
    }
  }
  return false;
}

// static
bool WebNNServiceStubDispatch::AcceptWithResponder(
    WebNNService* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kWebNNService_BindWebNNContextProvider_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWebNNServiceValidationInfo[] = {
    {internal::kWebNNService_BindWebNNContextProvider_Name,
     {&internal::WebNNService_BindWebNNContextProvider_Params_Data::Validate,
      nullptr /* no response */}},
};

bool WebNNServiceRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNService::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWebNNServiceValidationInfo);
}



}  // webnn::mojom


namespace mojo {


// static
bool StructTraits<::webnn::mojom::CreateContextOptions::DataView, ::webnn::mojom::CreateContextOptionsPtr>::Read(
    ::webnn::mojom::CreateContextOptions::DataView input,
    ::webnn::mojom::CreateContextOptionsPtr* output) {
  bool success = true;
  ::webnn::mojom::CreateContextOptionsPtr result(::webnn::mojom::CreateContextOptions::New());
  
      if (success && !input.ReadPowerPreference(&result->power_preference))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace webnn::mojom {


void WebNNContextInterceptorForTesting::CreateGraph(::webnn::mojom::GraphInfoPtr graph_info, CreateGraphCallback callback) {
  GetForwardingInterface()->CreateGraph(std::move(graph_info), std::move(callback));
}
WebNNContextAsyncWaiter::WebNNContextAsyncWaiter(
    WebNNContext* proxy) : proxy_(proxy) {}

WebNNContextAsyncWaiter::~WebNNContextAsyncWaiter() = default;

void WebNNContextAsyncWaiter::CreateGraph(
    ::webnn::mojom::GraphInfoPtr graph_info, ::mojo::PendingRemote<::webnn::mojom::WebNNGraph>* out_remote) {
  base::RunLoop loop;
  proxy_->CreateGraph(std::move(graph_info),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::mojo::PendingRemote<::webnn::mojom::WebNNGraph>* out_remote
,
             ::mojo::PendingRemote<::webnn::mojom::WebNNGraph> remote) {*out_remote = std::move(remote);
            loop->Quit();
          },
          &loop,
          out_remote));
  loop.Run();
}

::mojo::PendingRemote<::webnn::mojom::WebNNGraph> WebNNContextAsyncWaiter::CreateGraph(
    ::webnn::mojom::GraphInfoPtr graph_info) {
  ::mojo::PendingRemote<::webnn::mojom::WebNNGraph> async_wait_result;
  CreateGraph(std::move(graph_info),&async_wait_result);
  return async_wait_result;
}




void WebNNContextProviderInterceptorForTesting::CreateWebNNContext(CreateContextOptionsPtr options, CreateWebNNContextCallback callback) {
  GetForwardingInterface()->CreateWebNNContext(std::move(options), std::move(callback));
}
WebNNContextProviderAsyncWaiter::WebNNContextProviderAsyncWaiter(
    WebNNContextProvider* proxy) : proxy_(proxy) {}

WebNNContextProviderAsyncWaiter::~WebNNContextProviderAsyncWaiter() = default;

void WebNNContextProviderAsyncWaiter::CreateWebNNContext(
    CreateContextOptionsPtr options, CreateContextResult* out_result, ::mojo::PendingRemote<WebNNContext>* out_remote) {
  base::RunLoop loop;
  proxy_->CreateWebNNContext(std::move(options),
      base::BindOnce(
          [](base::RunLoop* loop,
             CreateContextResult* out_result
,
             ::mojo::PendingRemote<WebNNContext>* out_remote
,
             CreateContextResult result,
             ::mojo::PendingRemote<WebNNContext> remote) {*out_result = std::move(result);*out_remote = std::move(remote);
            loop->Quit();
          },
          &loop,
          out_result,
          out_remote));
  loop.Run();
}






void WebNNServiceInterceptorForTesting::BindWebNNContextProvider(::mojo::PendingReceiver<WebNNContextProvider> receiver) {
  GetForwardingInterface()->BindWebNNContextProvider(std::move(receiver));
}
WebNNServiceAsyncWaiter::WebNNServiceAsyncWaiter(
    WebNNService* proxy) : proxy_(proxy) {}

WebNNServiceAsyncWaiter::~WebNNServiceAsyncWaiter() = default;






}  // webnn::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif