// third_party/blink/public/mojom/loader/resource_cache.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_RESOURCE_CACHE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_RESOURCE_CACHE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/loader/resource_cache.mojom-shared.h"
#include "third_party/blink/public/mojom/loader/resource_cache.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class ResourceCacheProxy;

template <typename ImplRefTraits>
class ResourceCacheStub;

class ResourceCacheRequestValidator;
class ResourceCacheResponseValidator;


class BLINK_COMMON_EXPORT ResourceCache
    : public ResourceCacheInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = ResourceCacheInterfaceBase;
  using Proxy_ = ResourceCacheProxy;

  template <typename ImplRefTraits>
  using Stub_ = ResourceCacheStub<ImplRefTraits>;

  using RequestValidator_ = ResourceCacheRequestValidator;
  using ResponseValidator_ = ResourceCacheResponseValidator;
  enum MethodMinVersions : uint32_t {
    kContainsMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Contains_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~ResourceCache() = default;


  using ContainsCallback = base::OnceCallback<void(ResourceCacheContainsResultPtr)>;
  
  virtual void Contains(const ::GURL& url, ContainsCallback callback) = 0;
};



class BLINK_COMMON_EXPORT ResourceCacheProxy
    : public ResourceCache {
 public:
  using InterfaceType = ResourceCache;

  explicit ResourceCacheProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Contains(const ::GURL& url, ContainsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT ResourceCacheStubDispatch {
 public:
  static bool Accept(ResourceCache* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ResourceCache* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ResourceCache>>
class ResourceCacheStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ResourceCacheStub() = default;
  ~ResourceCacheStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ResourceCacheStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ResourceCacheStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT ResourceCacheRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT ResourceCacheResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_COMMON_EXPORT ResourceCacheContainsResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ResourceCacheContainsResult, T>::value>;
  using DataView = ResourceCacheContainsResultDataView;
  using Data_ = internal::ResourceCacheContainsResult_Data;
  using LifecycleState = ResourceCacheContainsResult_LifecycleState;

  template <typename... Args>
  static ResourceCacheContainsResultPtr New(Args&&... args) {
    return ResourceCacheContainsResultPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ResourceCacheContainsResultPtr From(const U& u) {
    return mojo::TypeConverter<ResourceCacheContainsResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ResourceCacheContainsResult>::Convert(*this);
  }


  ResourceCacheContainsResult();

  ResourceCacheContainsResult(
      bool is_in_cache,
      ::base::TimeTicks ipc_response_time,
      bool is_visible,
      ResourceCacheContainsResult::LifecycleState lifecycle_state);


  ~ResourceCacheContainsResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ResourceCacheContainsResultPtr>
  ResourceCacheContainsResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ResourceCacheContainsResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ResourceCacheContainsResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ResourceCacheContainsResult_UnserializedMessageContext<
            UserType, ResourceCacheContainsResult::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ResourceCacheContainsResult::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ResourceCacheContainsResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ResourceCacheContainsResult_UnserializedMessageContext<
            UserType, ResourceCacheContainsResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ResourceCacheContainsResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool is_in_cache;
  
  ::base::TimeTicks ipc_response_time;
  
  bool is_visible;
  
  ResourceCacheContainsResult::LifecycleState lifecycle_state;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ResourceCacheContainsResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ResourceCacheContainsResultPtr ResourceCacheContainsResult::Clone() const {
  return New(
      mojo::Clone(is_in_cache),
      mojo::Clone(ipc_response_time),
      mojo::Clone(is_visible),
      mojo::Clone(lifecycle_state)
  );
}

template <typename T, ResourceCacheContainsResult::EnableIfSame<T>*>
bool ResourceCacheContainsResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->is_in_cache, other_struct.is_in_cache))
    return false;
  if (!mojo::Equals(this->ipc_response_time, other_struct.ipc_response_time))
    return false;
  if (!mojo::Equals(this->is_visible, other_struct.is_visible))
    return false;
  if (!mojo::Equals(this->lifecycle_state, other_struct.lifecycle_state))
    return false;
  return true;
}

template <typename T, ResourceCacheContainsResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.is_in_cache < rhs.is_in_cache)
    return true;
  if (rhs.is_in_cache < lhs.is_in_cache)
    return false;
  if (lhs.ipc_response_time < rhs.ipc_response_time)
    return true;
  if (rhs.ipc_response_time < lhs.ipc_response_time)
    return false;
  if (lhs.is_visible < rhs.is_visible)
    return true;
  if (rhs.is_visible < lhs.is_visible)
    return false;
  if (lhs.lifecycle_state < rhs.lifecycle_state)
    return true;
  if (rhs.lifecycle_state < lhs.lifecycle_state)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::ResourceCacheContainsResult::DataView,
                                         ::blink::mojom::ResourceCacheContainsResultPtr> {
  static bool IsNull(const ::blink::mojom::ResourceCacheContainsResultPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::ResourceCacheContainsResultPtr* output) { output->reset(); }

  static decltype(::blink::mojom::ResourceCacheContainsResult::is_in_cache) is_in_cache(
      const ::blink::mojom::ResourceCacheContainsResultPtr& input) {
    return input->is_in_cache;
  }

  static const decltype(::blink::mojom::ResourceCacheContainsResult::ipc_response_time)& ipc_response_time(
      const ::blink::mojom::ResourceCacheContainsResultPtr& input) {
    return input->ipc_response_time;
  }

  static decltype(::blink::mojom::ResourceCacheContainsResult::is_visible) is_visible(
      const ::blink::mojom::ResourceCacheContainsResultPtr& input) {
    return input->is_visible;
  }

  static decltype(::blink::mojom::ResourceCacheContainsResult::lifecycle_state) lifecycle_state(
      const ::blink::mojom::ResourceCacheContainsResultPtr& input) {
    return input->lifecycle_state;
  }

  static bool Read(::blink::mojom::ResourceCacheContainsResult::DataView input, ::blink::mojom::ResourceCacheContainsResultPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_RESOURCE_CACHE_MOJOM_H_